Add FreeBSD's mpr(4) driver for LSI Fusion-MPT 3/3.5 SAS controllers.
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 5.2 TO LATER VERSIONS                +
13 +-----------------------------------------------------------------------+
14
15 IPSEC, IPSEC_ESP AND IPSEC_DEBUG REMOVED FROM VKERNEL64 CONFIG
16 --------------------------------------------------------------
17
18 IPsec has been removed from the system. Of our standard kernel
19 configurations, only the virtual kernel one had it. People running
20 vkernels with configuration files derived from our VKERNEL64 will
21 have to remove these options manually.
22
23 +-----------------------------------------------------------------------+
24 +         UPGRADING DRAGONFLY FROM 5.0 TO LATER VERSIONS                +
25 +-----------------------------------------------------------------------+
26
27 VIRTIO_PCI REMOVED FROM KERNEL CONFIG
28 -------------------------------------
29
30 The "device virtio_pci" line in X86_64_GENERIC has been removed. People
31 with configuration files derived from it have to remove it manually.
32
33 VARIOUS 'R' COMMANDS AND DAEMONS REMOVED
34 ----------------------------------------
35
36 rcp(1), rlogin(1), rlogind(8), rsh(1) and rshd(8) have been removed.
37 For those that still need them, there is the net/bsdrcmds port.
38
39 VARIOUS FORMER OPTIONS REMOVED
40 ------------------------------
41
42 Various former kernel configuration options which had been no-ops for
43 some time were completely removed: SYSVMSG, SYSVSEM, SYSVSHM, P1003_1B,
44 _KPOSIX_VERSION and DSCHED_FQ. Users that have any of these still in
45 their kernel configuration files have to remove them.
46
47 BOOTSTRAPPING LIMITED FROM PRE 4.4
48 ----------------------------------
49
50 Upgrading to 5.1 and later versions now require at least 4.4 in
51 preparations for upcoming base compilers updates.
52
53 IF_PPP, PPPD, IF_FAITH, AND FAITHD REMOVED
54 ------------------------------------------
55
56 if_ppp has been replaced by "user ppp", i.e. ppp(8) and tun(4). It had
57 already been removed from our default kernel configuration before 5.0,
58 so only people with custom configurations based on earlier X86_64_GENERIC
59 will have to remove it manually.
60
61 The faith(4) interface has been completely removed after it had also
62 been removed from our default kernel configuration. 
63
64 +-----------------------------------------------------------------------+
65 +         UPGRADING DRAGONFLY FROM 4.8 TO LATER VERSIONS                +
66 +-----------------------------------------------------------------------+
67
68 FFS_ROOT OPTION DISABLED
69 ------------------------
70
71 The FFS_ROOT option has been made a no-op and will be completely removed
72 at some point in the future. Users with a custom kernel configuration
73 can remove this option from it now.
74
75 +-----------------------------------------------------------------------+
76 +         UPGRADING DRAGONFLY FROM 4.6 TO LATER VERSIONS                +
77 +-----------------------------------------------------------------------+
78
79 AHC, AHD, AIC, NCV, NSP AND STG DRIVERS REMOVED
80 -----------------------------------------------
81
82 They were all in our X86_64_GENERIC kernel configuration file, along with
83 the AHC_REG_PRETTY_PRINT and AHD_REG_PRETTY_PRINT options, so any custom
84 configuration files derived from it need adjustment.
85
86 PORTAL FILE SYSTEM REMOVED
87 --------------------------
88
89 It has been broken for a long time now.
90
91 BINUTILS 2.27 REPLACES 2.24, PRIMARY
92 ------------------------------------
93
94 The oldest of the two versions of Binutils, version 2.24, was removed
95 and replaced with Binutils 2.27.  It becomes the primary version version
96 of binutils and version 2.25 becomes the alternate.
97
98 The accepted values of BINUTILSVER are now "binutils227" (default) and
99 "binutils225".  The building of Binutils 2.25 can be prevented by setting
100 NO_ALTBINUTILS=yes in make.conf.
101
102 COMPAT_43 KERNEL OPTION REMOVED
103 -------------------------------
104
105 It was commented out in our default configs for several years now, but
106 might still be present in custom configs created before Nov. 2011.
107
108 OPENSSL REMOVED
109 ---------------
110
111 OpenSSL has been removed from base and replaced with a private version of
112 LibreSSL.  The previously installed OpenSSL libraries, headers, and man
113 pages will remain on the system unless the "make upgrade" command is
114 specifically instructed to remove them.  To do this, define
115 REMOVE_OPENSSL_FILES for the upgrade command, e.g.
116 "make upgrade REMOVE_OPENSSL_FILES=yes"
117
118 28-Oct-2016: openssl has been replaced by ressl.  It is recommended that any
119 stale OpenSSL files be removed to avoid configuration scripts from using
120 the stale and potentially vulnerable version, but all binaries that are
121 dynamically linked to the OpenSSL libraries should be rebuilt first to
122 avoid breakage.
123
124 OPENSSH HPN REMOVED
125 -------------------
126
127 It has become too cumbersome to maintain HPN patches in OpenSSH in base.
128 To use OpenSSH in base remove HPN config, if you have added it.
129 Check files below for HPN config, see a few lines below.
130   /etc/ssh/ssh_config, /etc/ssh/sshd_config, ~/.ssh/config
131 sshd(8) will fail to start if HPN config is used.
132
133 NOTE: HPN config in sshd_config will prohibit remote access to host using ssh.
134
135 HPN config:
136 HPNDisabled
137 HPNBufferSize
138 TcpRcvBuf
139 TcpRcvBufPoll
140 NoneEnabled
141 NoneSwitch
142 cipher MTR-AES-CTR
143 cipher NONE
144
145 OpenSSH HPN is a patch set to OpenSSH providing higher performance under some
146 circumstances, especially for networking.
147 If HPN functionality is needed, install security/openssh from dports.
148
149 CS, EX AND VX DRIVERS REMOVED
150 -----------------------------
151
152 The cs(4), ex(4) and vx(4) drivers have been removed. They were very
153 old and its doubtful they ever worked properly in x86_64 but they were
154 in X86_64_GENERIC, so custom configurations derived from it have to be
155 adjusted.
156
157 +-----------------------------------------------------------------------+
158 +         UPGRADING DRAGONFLY FROM 4.4 TO LATER VERSIONS                +
159 +-----------------------------------------------------------------------+
160
161 AMD REMOVED
162 -----------
163
164 The am-utils automounter suite has been removed. It stopped working
165 at some point and was never fixed. autofs(5) and the associated
166 userland has been brought in from FreeBSD and replaces it.
167
168 AN DRIVER REMOVED
169 -----------------
170
171 The an(4) driver has been removed. It was in the X86_64_GENERIC kernel
172 config file, so any configurations derived from it have to be adjusted.
173
174 /DEV/DRI GROUP CHANGED
175 ----------------------
176
177 The default group assigned to /dev/dri entries has been changed
178 from 'wheel' to 'video' with the id of '44'. If you want to have
179 access to the dri devices please add yourself to the video group
180 with:
181
182 # pw groupmod video -m $USER
183
184 +-----------------------------------------------------------------------+
185 +         UPGRADING DRAGONFLY FROM 4.2 TO LATER VERSIONS                +
186 +-----------------------------------------------------------------------+
187
188 DSCHED REMOVED
189 --------------
190
191 dsched(4) has been removed and one of its kernel options, DSCHED_FQ, was
192 in our default kernel config file. So the DSCHED_FQ option has been turned
193 into a no-op for now and can be removed from custom configurations.
194
195 EST DRIVER REMOVED, COMPILE_ET AND LIBCOM_ERR TOO
196 -------------------------------------------------
197
198 The est(4) driver has been removed. All CPUs it supported (except one)
199 were 32 bits only. Those who are still using the Core 2 Duo T7500 should
200 report back if there are any issues with this CPU and our regular ACPI
201 P-state support.
202
203 Also, compile_et(1) and com_err(3) have been removed as well. They
204 should have been removed along with kerberos support, back in 2009.
205
206 SEVERAL LOCALES RENAMED
207 -----------------------
208
209 Several locales were using obsolete and misleading names, and thus have
210 been adjusted to current standards. Any users of the following locales
211 need to select alternates:
212
213 DFLY 4.2 locale            DFLY 4.4 alterative locale
214 ---------------            ------------------------------------
215 mn_MN.UTF-8                mn_Cyrl_MN.UTF-8
216 no_NO.UTF-8                nb_NO.UTF-8      or nn_NO.UTF-8
217 no_NO.ISO8859-1            nb_NO.ISO8869-1  or nn_NO.ISO8859-1
218 no_NO.ISO8859-15           nb_NO.ISO8859-15 or nn_NO.ISO8859-15
219 sr_YU.UTF-8                sr_Cyrl_RS.UTF-8 or sr_Latn_RS.UTF-8
220 sr_YU.ISO8859-5            sr_Cyrl_RS.ISO8859-5
221 sr_YU.ISO8859-2            sr_Latn_RS.ISO8859-2
222 zh_CN.GBK                  zh_Hans_CN.GBK
223 zh_CN.UTF-8                zh_Hans_CN.UTF-8
224 zh_CN.eucCN                zh_Hans_CN.eucCN
225 zh_CN.GB2312               zh_Hans_CH.GB2312
226 zh_CN.GB18030              zh_Hans_CH.GB18030
227 zh_HK.Big5HKSCS            zh_Hant_HK.Big5HKSCS
228 zh_HK.UTF_8                zh_Hant_HK.UTF-8
229 zh_TW.Big5                 zh_Hant_TW.Big5
230 zh_TW.UTF-8                zh_Hant_TW.UTF-8
231
232 +-----------------------------------------------------------------------+
233 +         UPGRADING DRAGONFLY FROM 4.0 TO LATER VERSIONS                +
234 +-----------------------------------------------------------------------+
235
236 BINUTILS 2.25 REPLACES 2.22, PRIMARY
237 ------------------------------------
238
239 The oldest of the two versions of Binutils, version 2.22, was removed
240 and replaced with Binutils 2.25.  It becomes the primary version version
241 of binutils and version 2.24 becomes the alternate.  There are 8 current
242 CVE written against 2.24, so for security reasons version 2.25 should
243 always be used.
244
245 The accepted values of BINUTILSVER are now "binutils225" (default) and
246 "binutils224".  The building of Binutils 2.24 can be prevented by setting
247 NO_ALTBINUTILS=yes in make.conf.
248
249 LOADER OPTIONS CHANGED
250 ----------------------
251
252 Right after the development branch started, the Fred art accompanying the
253 loader menu was improved.  The line between Fred and the menu was removed
254 by default (but can optionally be returned) and the placement shifted as
255 a result.  The drawing was improved, and the colored version was improved,
256 changing the eyes and wing color from white to red.  A new color version
257 of Fred was added, one with a blue scheme.
258
259 The loader menu defaults have changed since release 4.0:  The vertical
260 line was removed, the loader is displayed in color by default*, and the
261 blue scheme is used.
262
263 The loader.conf changes are:
264 loader_color:   option has been removed
265 loader_plain:   option has been added, it changed menu to monochrome
266 fred_is_red:    changes color scheme from blue to red
267 fred_is_blue:   option existed only on 4.1, it has been removed
268 fred_separated: Adds line between Fred and menu (as seen previously)
269
270 * If loader.conf defines "console" as "comconsole" or "console" is defined
271   in the environment as "comconsole" then color will not be displayed,
272   even if loader_plain value is "NO".
273
274 SENDMAIL REMOVED FROM BASE
275 --------------------------
276
277 The only Mail Transfer Agent provided now is DragonFly Mail Agent (dma).
278 If the system being upgraded is still configured to use the sendmail
279 binaries from base, the "make upgrade" command will fail.
280
281 The administrator must change /etc/mail/mailer.conf to switch the
282 mailwrapper to dma or a DPorts-based MTA prior to running the upgrade
283 command that permanently removes sendmail executables and could
284 potentially break a running mail server.
285
286 Refer: http://www.dragonflybsd.com/docs/docs/newhandbook/mta/ for
287 detailed instructions on how to configure the MTA selection.
288
289 _KPOSIX_VERSION and P1003_1B OPTIONS REMOVED
290 --------------------------------------------
291
292 The _KPOSIX_VERSION and P1003_1B kernel options have been changed to
293 no-ops. They can be removed from custom kernel configurations.
294
295 SOUND SYSTEM UPDATED FROM FreeBSD 11-CURRENT
296 --------------------------------------------
297
298 Many more sound devices may be detected.
299
300 If the default device choosen isn't to your liking, setting the sysctl
301 hw.snd.default_unit to a different number will change it.
302
303 SCTP SUPPORT DROPPED
304 --------------------
305
306 Support for the SCTP protocol has been removed.
307
308 OLD USB DRIVERS REMOVED
309 -----------------------
310
311 The old USB stack, along with the kernel config option "device oldusb"
312 and the make.conf variable "WANT_OLDUSB" have been removed. This means
313 that for custom kernel configuration files which were derived from a
314 GENERIC or X86_64_GENERIC file prior to making the usb4bsd stack default,
315 various (old USB stack specific) devices will now complain about being
316 unknown:
317
318   * oldusb      (obviously)
319   * natausb     (not yet ported to usb4bsd)
320   * rue         (not yet ported to usb4bsd)
321   * ugen        (no longer needed in usb4bsd)
322   * urio        (not yet ported to usb4bsd)
323   * uscanner    (no longer needed in usb4bsd)
324
325 They should be removed or commented out in such custom kernel configs.
326
327 GCC 5
328 -----
329
330 The GCC 4.4 compiler has been retired.  It has been replaced by a GCC 5.1.
331 The following make.conf variables no longer work: NO_GCC44, NO_OBJC, and
332 NO_CXX.  The latter was never documented and the latest versions of GCC are
333 partially written in C++ so a C++ compiler is no longer optional.  In
334 practical terms it has not been optional for many years as other base
335 components are also written in C++.  The resource savings by avoiding
336 building Objective-C compiler is so small, the complexity added by NO_OBJC
337 internally was deemed a bad tradeoff so that is the reason for its removal.
338 Also note that no "info" pages are installed with GCC 5.  After this entry
339 was originally written, all info pages were removed from DragonFly.
340
341 GCC 5.1 has been designated as the primary compiler.  As such, there is a
342 new make.conf variable, NO_ALTCOMPILER.  It will block the rebuilding of
343 the designated secondary compiler, GCC 4.7.  However, while DPorts
344 primarily uses GCC 5 to build ports now, it still uses GCC 4.7 as well, so
345 if building ports from source is desired, don't block building of the
346 secondary compiler.
347
348 +-----------------------------------------------------------------------+
349 +         UPGRADING DRAGONFLY FROM 3.8 TO LATER VERSIONS                +
350 +-----------------------------------------------------------------------+
351
352 SMP AND DEVICE_POLLING OPTIONS MADE UNKNOWN
353 -------------------------------------------
354
355 DEVICE_POLLING was replaced by IFPOLL_ENABLE and the former SMP code is
356 the default now (even on single-core systems), both for, like, 21 months.
357 We kept the options around as no-ops as a convenience, to allow people
358 using the same config for the then current release and the then current
359 master. That period is now over, so any configs still having those
360 options have to be adjusted.
361
362 SYSVIPC SYSCALLS MADE NON-OPTIONAL
363 ----------------------------------
364
365 The code related to the SYSVMSG, SYSVSEM and SYSVSHM kernel options is
366 now compiled in by default. The options are no-ops for now.
367
368 DEFAULT DRIVER CHANGED FOR LSI "THUNDERBOLT" SERIES RAID CONTROLLERS
369 --------------------------------------------------------------------
370
371 The default driver for those controllers is now mrsas(4) due to reports
372 of file system corruption using the mfi(4) driver. The whole issue (and
373 how to deal with potential problems when switching) was explained here:
374
375 http://lists.dragonflybsd.org/pipermail/users/2014-July/128703.html
376
377 A tunable is provided for letting those controllers still attach via
378 the mfi(4) driver, hw.mrsas.mfi_enable (see mrsas(4) manual page).
379
380 OLDER NETWORK DRIVERS MOVED TO I386 ONLY
381 ----------------------------------------
382
383 The following drivers have been made i386 only: ed(4), sr(4), ng_sync_ar
384 and ng_sync_sr. ed(4) used to be in X86_64_GENERIC, so it has to be
385 removed in kernel configs derived from X86_64_GENERIC.
386
387 +-----------------------------------------------------------------------+
388 +         UPGRADING DRAGONFLY FROM 3.6 TO LATER VERSIONS                +
389 +-----------------------------------------------------------------------+
390
391 UPDATE FROM MOST RECENT 3.6
392 ---------------------------
393
394 Versions of 3.6 built before June 25th have a bug where installworld might 
395 crash during installation of the new initrd.  Upgrade to the latest version
396 of 3.6 before updating to 3.8 or later.
397
398 ATM, IPX, NCP AND NWFS SUPPORT DROPPED
399 --------------------------------------
400
401 Support for the IPX and NCP network protocols and for mouting NetWare
402 file systems has been dropped. Dito for ATM protocol support.
403
404 INITRD IMAGES NOW INSTALLED BY DEFAULT
405 --------------------------------------
406
407 An initial ramdisk image is now installed in /boot/kernel/initrd.img.gz
408
409 Older images installed under the file name of initrd.img will be removed
410 automatically by the make upgrade process.
411
412 USB4BSD IS NOW THE DEFAULT USB STACK
413 ------------------------------------
414
415 To get back to the old stack, put "WANT_OLDUSB=yes" in /etc/make.conf and
416 replace "device usb" with "device oldusb" in the kernel configuration.
417
418 MORE ISA SUPPORT DROPPED
419 ------------------------
420
421 ISA support has been dropped from the following drivers: adv(4), an(4),
422 ar(4), cs(4), digi(4), ed(4), ep(4), ex(4), fe(4), lnc(4), sbni(4),
423 si(4), sn(4), and stg(4).
424
425 +-----------------------------------------------------------------------+
426 +         UPGRADING DRAGONFLY FROM 3.4 TO LATER VERSIONS                +
427 +-----------------------------------------------------------------------+
428
429 ABI CHANGE
430 ----------
431
432 Installed third-party software (dports) will have to be rebuilt after upgrade,
433 or reinstalled from binary packages.
434
435 UPDATING FROM 3.4 TO 3.6
436 ------------------------
437
438 This only applies for this specific upgrade due to locale changes; it is 
439 not needed for upgrades after 3.6.  Please update in this order:
440
441 make buildworld
442 make buildkernel
443 make installworld
444 make installkernel
445 *reboot*
446 make upgrade
447
448 See this mailing list post for details:
449 http://lists.dragonflybsd.org/pipermail/users/2013-September/090163.html
450
451 CYRIX OPTIONS REMOVED
452 ---------------------
453
454 The following Cyrix related options have been removed: CPU_BTB_EN,
455 CPU_CYRIX_NO_LOCK, CPU_DIRECT_MAPPED_CACHE, CPU_DISABLE_5X86_LSSER,
456 CPU_FASTER_5X86_FPU, CPU_IORT, CPU_LOOP_EN, CPU_RSTK_EN, CPU_SUSP_HLT,
457 CYRIX_CACHE_WORKS, and CYRIX_CACHE_REALLY_WORKS
458
459 ISA SUPPORT REMOVED FROM RP(4)
460 ------------------------------
461
462 ISA support has been removed from the rp(4) driver. It is now PCI only.
463
464 +-----------------------------------------------------------------------+
465 +         UPGRADING DRAGONFLY FROM 3.2 TO LATER VERSIONS                +
466 +-----------------------------------------------------------------------+
467
468 COMPAT_SUNOS OPTION REMOVED
469 ---------------------------
470
471 The COMPAT_SUNOS option has been removed. It was meant to provide binary
472 compatibility with SunOS 4.x for the sparc32 port of 4.4BSD.
473
474 ISA SOUND CARD SUPPORT REMOVED
475 ------------------------------
476
477 The following modules have been removed (all for ISA sound cards):
478 snd_ad1816.ko, snd_ess.ko, snd_mss.ko, snd_sb8.ko, snd_sb16.ko, snd_sbc.ko
479
480 GCC 4.7
481 -------
482
483 DragonFly has switched base compilers.  GCC 4.7 is now the default
484 compiler and GCC 4.4 is the alternative compiler.  The "NO_GCC47" make
485 variable ceases to work now.
486
487 Users who wish to build only GCC 4.7 have to use NO_GCC44 in the
488 /etc/make.conf to prohibit GCC 4.4 from building.  However, using it is
489 highly discouraged.  There are a few packages in pkgsrc that do not build
490 with GCC 4.7 and the new "DPorts" system uses GCC 4.4 by default.  At
491 this time, it is recommended to keep both compilers on the base system.
492
493 SMP OPTION REMOVED
494 ------------------
495
496 The SMP kernel option has been made a no-op. All kernels now feature SMP
497 support. If you have 'options SMP' in your kernel config, you can as well
498 remove it.
499
500 DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
501 ---------------------------------------------------------------------------
502
503 The DEVICE_POLLING kernel option has been made a no-op and it has been
504 replaced by IFPOLL_ENABLE.  If you have 'options DEVICE_POLLING' in your
505 kernel config, you need to change it to IFPOLL_ENABLE.
506
507 Also, the KTR_POLLING kernel option has been removed, so it must be
508 removed from kernel configs that have it.
509
510 BUSLOGIC, CYCLADES AND STALLION ISA SUPPORT REMOVED
511 ---------------------------------------------------
512
513 The bt(4) driver for Buslogic SCSI adapters has been made PCI only. ISA
514 cards will no longer be detected.
515
516 The same has been done for Stallion multiport serial controllers. stli(4)
517 has been completely removed (along with the stlload(8) and stlstty(8)
518 utilities) and stl(4) was changed to support only PCI cards. Similarly,
519 ISA support was removed from cy(4) too. All these drivers are i386 only.
520
521 COMPAT_OLDISA OPTION GONE
522 -------------------------
523
524 The i386 specific COMPAT_OLDISA kernel option has been removed, since
525 nothing needs it anymore.
526
527 +-----------------------------------------------------------------------+
528 +         UPGRADING DRAGONFLY FROM 3.0 TO LATER VERSIONS                +
529 +-----------------------------------------------------------------------+
530
531 APIC_IO OPTION REMOVED
532 ----------------------
533
534 The APIC_IO kernel option is no longer accepted after having been without
535 effect for a while. The hw.ioapic_enable tunable now serves its purpose.
536 If you have 'options APIC_IO' in your kernel config, you'll have to
537 remove it.
538
539 WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
540 -----------------------------------------
541
542 The wdog framework is now compiled into our kernels by default, so the
543 options are no longer needed.
544
545 DOSCMD(1) REMOVED
546 -----------------
547
548 doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
549 NO_X make.conf option was removed too.
550
551 GCC 4.7
552 -------
553
554 GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
555 default compiler in base (default is still GCC 4.4).
556
557 Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
558 NO_GCC47 in /etc/make.conf.
559
560 USB4BSD
561 -------
562
563 A new USB stack (from FreeBSD) has been brought in. The following
564 modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
565 usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
566 and uaudio.
567
568 It is not yet the default. To activate it, WANT_USB4BSD=yes has to
569 be put in make.conf and device "usb4bsd" (quotes needed) has to
570 replace device usb in the kernel config. After that, a full
571 build/install/upgrade cycle is needed.
572
573 Note that this is experimental and incomplete, but we are interested
574 in hearing about issues with it, of course.
575
576 ISA SUPPORT REMOVED FROM AIC-6260/6360 DRIVER
577 ---------------------------------------------
578
579 ISA adapter support was dropped from the aic(4) driver.
580
581 +-----------------------------------------------------------------------+
582 +         UPGRADING DRAGONFLY FROM 2.10 TO LATER VERSIONS               +
583 +-----------------------------------------------------------------------+
584
585 SEVERAL ISA DRIVERS REMOVED
586 ---------------------------
587
588 The following ISA only drivers have been removed along with a couple of
589 associated userland tools:
590
591 aha(4)
592 asc(4) & sasc(1)
593 ctx
594 dgb(4)
595 el(4)
596 gpib
597 gsc(4) & sgsc(1)
598 ie(4)
599 labpc(4)
600 le(4)
601 mse(4)
602 rc(4)
603 rdp(4)
604 spigot
605 tw(4) & xten(1) & xtend(8)
606 wl(4) & wlconfig(8)
607 wt(4)
608
609 Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
610 config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
611 file.
612
613 If buildkernel complains about any of these drivers, just remove them
614 from your kernel configuration.
615
616 BINUTILS 2.20
617 -------------
618 Binutils 2.20 has been removed in favor of Binutils 2.22.  The accepted
619 values of BINUTILSVERS are now binutils221 and binutils222 (default).
620
621 BUILDWORLD/-KERNEL PARALLELIZATION WORK
622 ---------------------------------------
623 Due to changes in the way we build with more than one make job, you
624 will have to update install(1) and mkdir(1) prior to buildworld if you
625 want to build with 'make -j':
626
627 cd /usr/src/usr.bin/xinstall; make; make install; make clean
628 cd /usr/src/bin/mkdir; make; make install; make clean
629
630 DMA(8) UPGRADE
631 --------------
632 dma(8) has been upgraded to v0.7 which no longer supports the
633 /etc/dma/virtusertable. Some of its functionality has been replaced
634 with the MASQUERADE keyword and the EMAIL environment variable (see
635 the dma(8) manual page).
636
637 +-----------------------------------------------------------------------+
638 +         UPGRADING DRAGONFLY FROM 2.8 TO LATER VERSIONS                +
639 +-----------------------------------------------------------------------+
640
641 GCC 4.4 & BINUTILS 2.21
642 -----------------------
643
644 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
645 been made DragonFly's default Binutils.
646
647 That means that any settings that set CCVER to 'gcc44' are not needed
648 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
649 GCC 4.1.
650
651 It also means that 'binutils221' as a value for BINUTILSVER has no
652 effect anymore. 2.17 has been removed and 'binutils220' is available
653 as an option.
654
655 The NO_GCC44 option has been removed and will not affect the build
656 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
657 building in a similar fashion.
658
659 Note that you must do a full buildworld/buildkernel for upgrading.
660
661 pkg_radd settings
662 -----------------
663
664 The config file for pkg_radd has moved from /etc/settings.conf to 
665 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
666 if this is needed.  This warning only applies if /etc/settings.conf 
667 exists.  pkg_radd will continue to work with defaults.
668
669 +-----------------------------------------------------------------------+
670 +         20100927                                                      +
671 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
672 +-----------------------------------------------------------------------+
673
674 OpenSSL
675 --------
676
677 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
678 This shouldn't break any 3rd-party software, but you'll need to recompile your
679 3rd-party software if you want it to link against the new version of OpenSSL.
680
681 Loader
682 -------
683
684 A new loader (dloader) has been added which better handles booting from
685 multiple kernel/module versions.
686
687 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
688
689         cd /usr/src
690         make buildworld
691         make installworld
692         make upgrade
693         make buildkernel KERNCONF=<KERNELNAME>
694         make installkernel KERNCONF=<KERNELNAME>
695
696 Note that you must installworld and run the 'upgrade' target before
697 installing the new kernel.
698
699 BIND
700 -----
701
702 BIND has been removed from the base system.  The ldns and drill tools have 
703 been added for basic functionality.  Use 'drill' where you would normally 
704 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
705 net/bind95, net/bind96, or net/bind97 as of this writing.
706
707 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
708 include BIND as a pkgsrc package.
709
710 +-----------------------------------------------------------------------+
711 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
712 +                               GENERAL                                 +
713 +-----------------------------------------------------------------------+
714
715 Instructions on how to obtain and maintain DragonFly source code using git
716 are in the development(7) manual page.
717
718 To upgrade a DragonFly system from sources you run the following sequence:
719
720         cd /usr/src
721         make buildworld
722         make buildkernel KERNCONF=<KERNELNAME>
723         make installkernel KERNCONF=<KERNELNAME>
724         make installworld
725
726 You will also want to run the 'upgrade' target to upgrade your /etc and the
727 rest of your system.  The upgrade target is aware of stale files created by
728 older DragonFly installations and should delete them automatically.
729
730         make upgrade
731
732 See the build(7) manual page for further information.
733
734 Once you've done a full build of the world and kernel you can do incremental
735 upgrades of either by using the 'quickworld' and 'quickkernel' targets
736 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
737 the quick targets, try updating your repo first, and then a full buildworld
738 and buildkernel as shown above, before asking for help.
739
740 +-----------------------------------------------------------------------+
741 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
742 +-----------------------------------------------------------------------+
743
744 In 2.1 kernel and modules has moved to boot directory.  For most cases
745 this is handled automatically by 'make upgrade'.  A few cases needs manual
746 intervention:
747
748  * When installing a kernel without first doing a make buildworld,
749    installworld and upgrade to the same DESTDIR as kernel:
750    make DESTDIR/boot directory and move kernel and modules into this boot
751    directory; also move kernel.old and modules.old.
752    Typical example is vkernel(7), use (no modules used):
753
754         cd /var/vkernel
755         mkdir boot
756         chflags noschg kernel
757         mv kernel kernel.old boot
758         chflags schg boot/kernel
759         
760  * When using a boot-only partition, /boot/loader.rc needs to be edited:
761    delete occurrences of '/boot/'.
762    These occurences can normally be deleted in any case, see loader(8).
763
764 +-----------------------------------------------------------------------+
765 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
766 +-----------------------------------------------------------------------+
767
768 In 1.9 major changes to the disk management infrastructure have taken
769 place.  make upgrade may not catch all of your disk devices in /dev,
770 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
771 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
772 and MAKEDEV no longer exists.
773
774 The biggest changes in 1.9 are:
775
776 (1) That whole-slice devices such as da0s1 no longer share the same device
777     id as partition c devices such as da0s1c.
778
779 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
780     with no snooping or reserved sectors.  Consequently you cannot run
781     disklabel on this device.  Instead you must run disklabel on a
782     whole-slice device.
783
784 (3) The 'compatibility' partitions now use slice 0 in the device name,
785     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
786     accessing the disklabel for the compatibility partitions must be
787     done via slice 0 (da0s0).
788
789 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
790     and CCD now run through the disk management layer and are assigned
791     real disk management devices.   VN and CCD in particular do not usually
792     use a MBR and disklabels must be accessed through the compatibility
793     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
794     don't name it 'ccd0s0' in the config file.
795
796 Generally speaking, you have to get used to running fdisk and disklabel on
797 the correctly specified device names.  A lot of the wiggle, such as running
798 disklabel on a partition, has been removed.
799
800 +-----------------------------------------------------------------------+
801 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
802 +-----------------------------------------------------------------------+
803
804 > Kerberos IV
805 -------------
806
807 Kerberos IV (eBones) was removed from the tree, please consider moving to
808 Kerberos 5 (Heimdal).
809
810 > Package Management System
811 ---------------------------
812
813 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
814 management system.  The necessary tools to build and maintain packages
815 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
816 directories are in your PATH variable.
817
818 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
819 the tarball from NetBSD:
820
821         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
822         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
823
824 This tree can then be kept up to date with cvs update:
825
826         cd /usr/pkgsrc; cvs up
827
828 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
829 build and install the pkgsrc bootstrap manually:
830
831         cd /usr/pkgsrc/bootstrap
832         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
833
834 +-----------------------------------------------------------------------+
835 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
836 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
837 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
838 +-----------------------------------------------------------------------+
839
840 The compatibility shims for the build environment have been removed, you
841 have to update to DragonFly 1.2 release branch first.
842
843 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
844 The existing configuration can be converted using /etc/pam.d/convert.sh.
845 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
846 the pam_skey.so module was retired, you have to remove it manually from
847 your configuration, when you convert it.
848
849 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
850 ---------------------
851
852 The following users may be missing from your password file.  Use vipw and
853 add any that are missing:
854
855 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
856 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
857
858 The following groups may be missing from your group file.  Use vi /etc/group
859 and add any that are missing:
860
861 smmsp:*:25:
862 authpf:*:63:
863 _pflogd:*:64:
864
865
866 > Upgrading to DragonFly from FreeBSD
867 ---------------------
868
869 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
870 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
871 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
872 make depend information, it starts from scratch, so no pre-cleaning of the
873 object hierarchy is necessary.
874
875         # get the CVS repository (it is placed in /home/dcvs, 500MB).
876         # Please use the -h option and a mirror site to pull the 
877         # initial repository, but feel free to use the main repository
878         # machine to pull updates.
879         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
880         # install the source from the CVS hierarchy (remove preexisting
881         # FreeBSD src first) (500MB)
882         cd /usr
883         rm -rf src
884         cvs -R -d /home/dcvs checkout -P src
885
886         # build it (500MB used in /usr/obj)
887         #
888         cd /usr/src
889         make buildworld
890         make buildkernel KERNCONF=<KERNELNAME>
891
892 Once you have built DragonFly you have to install it over FreeBSD.  Since
893 DragonFly does not track changes made by FreeBSD to its include file 
894 hierarchy and include file pollution can cause all sorts of unexpected
895 compilation issues to come up, it is best to wipe your include hierarchy
896 prior to installing DragonFly.  Note that you should not wipe any installed
897 FreeBSD header files or binaries until after you have successfully completed
898 the build steps above.
899
900         rm -rf /usr/include
901         mkdir /usr/include
902         make installkernel KERNCONF=<KERNELNAME>
903         make installworld
904
905 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
906 will unconditionally upgrade the /etc files that sysops do not usually
907 mess around with, such as the files in /etc/rc.d.  It will also remove any
908 obsolete files such as utilities and manpages that have been removed from
909 the system since the version you're coming from.  If you are unsure we 
910 recommend that you make a backup of at least your /etc before applying
911 this step.  Note that DragonFly's RC system is basically RCNG from
912 FreeBSD-5, but there are some differences in the contents of the RC files.
913
914         make upgrade
915
916 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
917 Doing so might leave your system in an unusable state.
918
919 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
920 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
921 report these files to the DragonFly developers so that they can be added to
922 the 'upgrade' target.
923